#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "/usr/include/Neon/Neon.h"
using namespace std;

int checkRoot()
{
    int user;
    user = getuid();
    if(user)
        return false;

    return true;
}


int main(int ,char* [])
{
    if(!checkRoot())
    {
        cout << "Need root privileges, please use sudo command..."<<endl;
        return 0;
    }

    char version[256];
    cout << "\nGet Neon Device Information" << endl;
    int result=Neon_GetDeviceInfo(version,sizeof(version));
    if(result==COMMON_ERROR)
        cout << "Neon_GetDeviceInfo failed!" << endl;
    else
	cout << version << endl;

    unsigned int val=0;
    int ival=0;
    result=Neon_GetDINums(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetDINums failed!" << endl;
    else
        cout << "DI Nums:"<<val<< endl;	

    for(unsigned int i=0;i<(unsigned int)val;i++)
    {
        int state=0;
        result=Neon_GetDIState(i,&state);
        if(result==COMMON_ERROR)
            continue;
        else
            cout << "DI"<<i<<"state:"<<state<<endl;
    }

    result=Neon_GetDI0Config(&ival);
    if(result==COMMON_ERROR)
        cout << "Neon_GetDI0Config failed!" << endl;
    else
        cout << "DI0 Config:"<<ival<< endl;

    result=Neon_GetDONums(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetDONums failed!" << endl;
    else
        cout << "DO Nums:"<<val<< endl;

    for(unsigned int i=0;i<(unsigned int)val;i++)
    {
        int state=0;
        result=Neon_GetDOState(i,&state);
        if(result==COMMON_ERROR)
            continue;
        else
            cout << "DO"<<i<<"state:"<<state<<endl;
    }

    result=Neon_GetDO0Config(&ival);
    if(result==COMMON_ERROR)
        cout << "Neon_GetDO0Config failed!" << endl;
    else
        cout << "DO0 Config:"<<ival<< endl;

    result=Neon_GetStrobeOutEnable(&ival);
    if(result==COMMON_ERROR)
        cout << "Neon_GetStrobeOutEnable failed!" << endl;
    else
        cout << "StrobeOut Enable:"<<ival<< endl;

    result=Neon_GetStrobeOutDelay(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetStrobeOutDelay failed!" << endl;
    else
        cout << "StrobeOut delay:"<<val<<"us"<< endl;

    result=Neon_GetStrobeOutPulseWidth(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetStrobeOutPulseWidth failed!" << endl;
    else
        cout << "StrobeOut pulse width:"<<val<<"us"<< endl;

    result=Neon_GetExposureDelay(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetExposureDelay failed!" << endl;
    else
        cout << "Exposure delay:"<<val<<"us"<< endl;


    result=Neon_GetDebounceTime(&val);
    if(result==COMMON_ERROR)
        cout << "Neon_GetDebounceTime failed!" << endl;
    else
        cout << "Get Debounce time:"<<val<<"x40ns"<< endl;



    return 0;
}

